CartomENS-IA
===

[![pipeline status](http://gitlab.aliens-lyon.fr/CartomENSiens/CartomENS-IA/badges/client/pipeline.svg)](http://gitlab.aliens-lyon.fr/CartomENSiens/CartomENS-IA/commits/client)

# Cadre
Projet Intégré du cours d'Informatique Fondamentale de l'ENS de Lyon, dans le cadre du Master 1 2017-2018.

# Buts et objectifs
- Développer une intelligence artificielle jouant à la Batarde
- Implémenter une appli pour Mobile et PC pour y jouer contre l'IA
- Développer un mode multi joueurs en ligne
- Conquerir le monde

# Dependances
- `SFML >= 1.5`
- `libsodium >= 1.0.16`
- `cmake`

# Utilisation
- Compiler ```$ make```
- Lancer ```$ make run```
- Nettoyer ```$ make clean```
- Générer uniquement la doc ```$ make doc```

# Equipe de choc

- Benoit Tristan
- Bethune Louis
- Blondeau-Patissier Lison
- Champseix Nicolas
- Coiffier Guillaume
- Deschamps Quentin
- Devevey Julien
- Fernandez Simon
- La Xuan Hoang
- Lechine Ulysse
- Pitois François
- Pouget Stephane
- Rochette Denis
- Vacus Robin
- Valentin Herménégilde
- Valque Léo
- Vavrille Mathieu
- Florent Guepin
- Eddy Caron (Coach de Choc)

# Work Packages
- Communication
- GUI/Archi  PC
- GUI/Archi  Telephone
- IA
- Serveur et reseau
- Tutos
- Tests

# Coding standards
- Indentation: 4 espaces
- ClassName (no underscore)
- method_name (starts with a verb)
- variableName (at least 3 caracters, exception for loop variables that are not multiple loop (length, heigh, ...) and no type reference (str -> theText)
- no plural in names (tab instead of tabs)
- full english
- .hpp -> documentation of all non trivial functions (not a .h)
- maximal factorisation
- 1 class = 1 .hpp and 1 .cpp
- int const
- no hardcode (global constants defined in the .hpp), no preprocessing utilisation
- non native types given as references

## Mobile client coding standards
- Automatic identation of Android Studio
- Documentation generated with Android Studio
- ClassName
- methodName (generaly starts with a verb)
- variableName (at least 3 caracters, exception for loop variables that are not multiple loop (length, heigh, ...) and no type reference (str -> theText)
- no plural in names (tab instead of tabs)
- full english
