#pragma once

/** \file
* \author Léo.V
* \brief Definition of class GraphicTimer
**/

#include <SFML/Graphics.hpp>
#include <cmath>
#include "Constants.hpp"

/** \class **/
class GraphicTimer{
    public:
        GraphicTimer(sf::Vector2f center, int size, int sizeOutline=10, sf::Color begin = RED, sf::Color end = GREEN);
        GraphicTimer(int x, int y, int size, int sizeOutline=10, sf::Color begin = RED, sf::Color end = GREEN);

        void reduce();
        void update(sf::RenderWindow&);

    private:
        sf::Vector2f getPoint(std::size_t index, int size, int sizeOutline) const;

        int m_size;
        unsigned int m_nbPointsDrawn;
        unsigned int m_nbPoints;
        sf::Vector2f m_center;

        std::vector<sf::Vertex> m_vertices;

        int compteur_temp;

};
