#ifndef DEF_CLASS_LOADING
#define DEF_CLASS_LOADING

#include <SFML/Graphics.hpp>
#include <string>

#include "AnimatedSprite.hpp"
#include "Message.hpp"
#include "TextManager.hpp"
#include "RessourceManager.hpp"
#include "enumType.hpp"

/** \file
    \author GUIllaume C.
    \brief Definition of class Loading
**/

/** \class
*   \brief A loading message that is animated
**/
class Loading {

public:
    Loading() = default;

    Loading(sf::Vector2f const position);
    Loading(sf::Vector2i const position);
    Loading(float const posX, float const posY);

    void update(sf::RenderWindow& app);

    static int const SPRITE_OFFSET;

private:
    static std::wstring onePt; // "."
    static std::wstring twoPt; // ".."
    static std::wstring threePt; // "..."

    int m_loadingPhase; // from 0 to 3
    std::wstring m_loadStr;

    Message m_loadingMessage;
    AnimatedSprite m_loadingSprite;
};

#endif
