#pragma once

#include <unordered_map>
#include <memory>
#include <string>
#include <vector>

#include <SFML/Audio.hpp>

/** \file SoundManager.hpp
*   \author Louis.B, GUIllaume.C
*   \brief Definition of the SoundManager class
*/

/** \class
*   \brief
**/
class SoundManager {
public:
    SoundManager();
    bool preload_sound(const std::string& filename);
    bool play_sound(const std::string& filename);

    bool play_music(const std::string& filename);
    void stop_music(const std::string& filename);

    void mute();

    void set_sound_volume(int);
    int get_sound_volume();

    void set_music_volume(int);
    int get_music_volume();

private:
    int m_soundVolume;
    int m_musicVolume;
    std::vector<sf::Sound> m_sounds;
    std::unordered_map<std::string, std::unique_ptr<sf::SoundBuffer>> m_buffers;
    std::unordered_map<std::string, std::unique_ptr<sf::Music>> m_musics;
};

extern SoundManager soundManager;
