#ifndef DEF_TOKENARRAY
#define DEF_TOKENARRAY

#include <vector>
#include "Token.hpp"
#include "Card.hpp"

/** \file
*	\author Leo.V, Mathieu.V
*	\date 10 October
*	\brief Definition of class TokenArray
**/


/** \class
*	\brief DOCUMENTATION TODO
**/
class TokenArray{
public:
	TokenArray();
	TokenArray(sf::Vector2f position, int orientation = 0, double scale = 1); //give the position of the center of the hand

    void set_nb_token(int nb); //reset the nb_plis to 0;

	void draw(sf::RenderWindow &window);

	void replace_token(int time=15); //replace token

	sf::Vector2f get_position_token_free();

	void new_trick();
	void draw_new_trick();
	sf::Vector2f get_pos_free_token();

	double get_scale();
	bool is_animated();

private:
	sf::Vector2f compute_position(int i, int n); //call by replace to make fan

	std::vector<Token> m_tokenPlayer;
	std::vector<Card> m_cardToken;

	int m_nbToken;
	int m_nbTrick;
	int m_nbTrickDraw;
	Card m_card;

	sf::Vector2f m_centerArray; //position of the center of the hand
	double m_scaleArray; //the scale of the card
    int m_orientationArray; //orientation of the hand in degree

};

#endif
