#ifndef DEF_ENUM_CLASSES
#define DEF_ENUM_CLASSES

#include <string>

/**
    \file enumType.hpp
    \author GUIllaume.C
    \brief Definition of enum classes Language, Align
**/

// ____ Enum types _____

enum class Language : int {
/**
    \enum Language
    \brief Language enum used by the option manager
**/
    ENGLISH,
    FRENCH,
    GERMAN,
    SPANISH,
    ITALIAN,
    PORTUGUESE,
    PIRATE
};

std::string language_to_string(Language const);
Language string_to_language(std::string const&);

enum class Align {
/**
    For message and button alignment
**/
    CENTER_TOP,
    CENTER,
    LEFT,
    RIGHT
};

enum class Difficulty {
    /** AI Difficulty **/
    EASY,
    MEDIUM,
    HARD
};

std::string difficulty_to_string(Difficulty const);
Difficulty string_to_difficulty(std::string const&);

#endif
