#pragma once
#include <string>

/** \file
* \author GUIllaume C.
* \brief Definition of the function that splits strings onto several lines
**/

/** \brief Splits the string into several lines
*   \param width the width of the zone where the text should be displayed. Act as a constraint
*   \param fontSize size of the font of the given text. Determines the width of the characters.
*   \param src the input string to split. /!\ Works in place
*   \return the number of lines created
**/
int split_string(std::string &src, int fontSize, int width);
int split_string(std::wstring &src, int fontSize, int width);
