#pragma once

#include <sodium.h>
#include <iostream>
#include <stdexcept>
#include <SFML/Network.hpp>
#include <string.h>

using namespace std;

namespace Network{

	class CryptoBox {
	public:
		CryptoBox(bool);
		void init(unsigned char *);
    	void cypher_message( unsigned char*, unsigned char*, size_t);
    	void decypher_message(unsigned char*, unsigned char*, size_t);

    	unsigned char * public_key();

	private:
        unsigned char m_public_key[crypto_kx_PUBLICKEYBYTES], m_private_key[crypto_kx_SECRETKEYBYTES];
        unsigned char m_receive_key[crypto_kx_SESSIONKEYBYTES], m_send_key[crypto_kx_SESSIONKEYBYTES];
		uint64_t m_nonce;

		bool m_isClient;
        
    };
	void toto();
}
