#pragma once

#include <memory>

#include <SFML/Network.hpp>
#include "Core.hpp"
#include "CryptoBox.hpp"

namespace Network {

    /** An network interface for a Core::Player, that just forwards the requests **/
    class RemotePlayer: public Core::Player {
    public:
        /** \brief Initialises the RemotePlayer with a socket
        * \param socket A socket connected to the client on which a RemoteKernel is listenning **/
        RemotePlayer(std::shared_ptr<sf::TcpSocket>, CryptoBox *);
        Core::Bet bet();
        bool mechoune();
        bool choune();
        Core::Card play();

        void set_game_state(const Core::GameState& gameState);

        /** \brief Create a RemotegameState as a GameState **/
        virtual std::unique_ptr<Core::GameState> create_game_state(int id);

    private:
        /** \brief The socket to communicate with the client **/
        std::shared_ptr<sf::TcpSocket> m_socket;

        CryptoBox * m_crypto;
    };
}
