#pragma once

#include <SFML/Network.hpp>
#include <iostream>

#include "Reseau.hpp"
#include "ServerConstants.hpp"
#include "ServerMessage.hpp"

namespace Network{

	class ServerCommunication {
	public:
		ServerCommunication(sf::IpAddress addr, unsigned short port);

		sf::Socket::Status init();
    	
    	RemoteKernel * create_game(Core::Player *);
		RemoteKernel * join_game(Core::Player *, char);
    	RemoteKernel * join_matchmaking(Core::Player *);

		void start_game();

    private:
        sf::IpAddress m_addr;
        unsigned short m_port;
        sf::Time m_timeout;

        shared_ptr<sf::TcpSocket> m_socket;
        CryptoBox * m_crypto;
	};
}
