#include "Constants.hpp"

// _________ String Trump ___________

std::vector<std::string> const NAME_TRUMP = {"without_trump","club","diamond","heart","spade","all_trump"};
std::vector<std::wstring> const NAME_VALUE = {L"1", L"2", L"J", L"M", L"F", L"V", L"C", L"D", L"R"};

// ________ Splash Screen ___________

double const SPLASH_TIME = 1.0; //1.0 in seconds
double const FADE_SPEED = 20.0; // 20.0

// ________ Window Resolutions ________
std::vector<std::wstring> const RESOLUTION = {L"800x600", L"1080x720", L"1600x900", L"1920x1080"};

std::vector<int> const RESOLUTION_WIDTH = {800,1080,1600,1920};
std::vector<int> const RESOLUTION_HEIGHT = {600,720,900,1080};

int const NB_RESOLUTION = RESOLUTION.size();

// ________ Window Size ________
int const WINDOW_WIDTH = optionManager()->get_screen_width();
int const WINDOW_HEIGHT = optionManager()->get_screen_height();

double const SCALE_RESOLUTION_WIDTH = double(WINDOW_WIDTH) / 1080.0;
double const SCALE_RESOLUTION_HEIGHT = double(WINDOW_HEIGHT) / 720.0;

double const SCALE_RESOLUTION = SCALE_RESOLUTION_WIDTH;

// ______ Colors ______

sf::Color const WHITE(255,255,255);
sf::Color const YELLOW(255,255,0);
sf::Color const BLUE(0,0,255);
sf::Color const BLACK(0,0,0);
sf::Color const GRAY(180,180,180);
sf::Color const GRAY_LIT(230,230,230);
sf::Color const GREEN(0,180,0);
sf::Color const GREEN_LIT(50,230,50);
sf::Color const RED(180,0,0);
sf::Color const RED_LIT(230,50,50);
sf::Color const TRANSPARENT(255,255,255,64);
sf::Color const BACKGROUND(0,74,153);

// ______ Font size constants ______
int const TITLE_FONT_SIZE = 80*SCALE_RESOLUTION;
int const MENU_BUTTON_FONT_SIZE = 40*SCALE_RESOLUTION;
int const LOGIN_FONT_SIZE = 22*SCALE_RESOLUTION;
int const LOGIN_FAIL_FONT_SIZE= 25*SCALE_RESOLUTION;
int const OPTION_FONT_SIZE = 30*SCALE_RESOLUTION;
int const OPTION_FONT_WARNING_SIZE = 22*SCALE_RESOLUTION;
int const STAT_FONT_SIZE = 20*SCALE_RESOLUTION;
int const TROPHY_NAME_SIZE = 22;
int const TROPHY_TEXT_SIZE = 18;

// ______ Math constants ______
double const PI = 3.14159265;

// _______ Main menu Constants _______
int const MENU_SPACE_UNDER_TITLE = 50+WINDOW_WIDTH/35*(SCALE_RESOLUTION < 1 ? 1 : SCALE_RESOLUTION);
int const SELECTION_MENU_SPACE_UNDER_TITLE = WINDOW_WIDTH/15;
int const SELECTION_MENU_SPACE_UNDER_TITLE2 = 50+WINDOW_WIDTH/15;
int const SELECTION_MENU_SPACE_UNDER_TITLE3 = WINDOW_WIDTH/20;
int const MENU_OFFSET = ((WINDOW_HEIGHT - 350)/2)/(1+SCALE_RESOLUTION);

//________ Option menu Constants ________
int const OPTION_SPACE_UNDER_TITLE = WINDOW_WIDTH/15;
int const OPTION_OFFSET = (WINDOW_HEIGHT-200)/6;
int const GRAPHIC_OPTION_VERTICAL_LINE_POS = WINDOW_WIDTH/4;
int const GAME_OPTION_VERTICAL_LINE_POS = WINDOW_WIDTH/2;
int const FLAG_SIZE = (100*WINDOW_WIDTH)/1920;

//_________ Center Play Zone ________
int const CENTER_PLAY_X = WINDOW_WIDTH/2;
int const CENTER_PLAY_Y = WINDOW_HEIGHT/2 - 10;

// ______ Player Mark Size _______
int const PLAYER_MARK_SIZE = 200;

// ______ Card Size _______
int const WIDTH_CARD = 100;
int const LENGTH_CARD = 141;

double const SCALE_CARD = SCALE_RESOLUTION;

int const TIME_WAIT_TRICK = 500;
int const TIME_TROPHY_APPEAR = 5000;

// _______ BETBUBBLE Constant _______

int const HEIGHT_BETBUBBLE = 180 * SCALE_RESOLUTION;
int const WIDTH_BETBUBBLE = HEIGHT_BETBUBBLE * 40 / 25;

int const SIZE_TEXT_BETBUBBLE = 40 * SCALE_RESOLUTION;

int const DIST_HAND_BETBUBBLE = 120 * SCALE_RESOLUTION;

int const TIME_BETBUBBLE_ANIMATION = 30;

// _____ Card Speed _______

int const C_DISTRIB_TIME = 10; //need C_DISTRIB_TIME ticks to arrive
int const C_REPLACE_TIME = 10;
int const C_PLAY_TIME = 30;
int const C_TRICK_TIME = 20;

// ______ Game Constant ________
double const DISTRIBUTION_SPEED = 1.5;

// ______ Hand Constant ________
int const ANGLE_FAN = 5; //degre between each card
int const CARD_SPACING = WIDTH_CARD * 0.7; //degree of superposition
int const DISTANCE_CIRCLE_CENTER = CARD_SPACING * 360 / (ANGLE_FAN*2*PI);

// ________ Player Icon Constant _________
int const ICON_SIZE = 80*SCALE_RESOLUTION;

// ________ Token Constant _________

int const REAL_WIDTH_TOKEN = 450 * SCALE_RESOLUTION;
int const WIDTH_TOKEN = 75;
double const SCALE_TOKEN = 0.6 * SCALE_RESOLUTION;

// _______ Trophies Drawner Constant ___________
int const WIDTH_TROPHIES_DRAWER = 400;
int const HEIGHT_TROPHIES_DRAWER = 150;
int const SIZE_TROPHIES_PICTURE = 100;

//_________BetArray Constant _________
//Real sizes of variables, the size of trumps' aura is such that it is the same
//for all trumps (and without and all trumps)
int const REAL_WIDTH_AURA_TOKEN = 700 * SCALE_RESOLUTION;
int const REAL_HEIGHT_TRUMP = 183 * SCALE_RESOLUTION;
int const REAL_HEIGHT_AURA_TRUMP = 263 * SCALE_RESOLUTION;
int const REAL_WIDTH_ALL_WITHOUT_TRUMP = 227 * SCALE_RESOLUTION;
int const REAL_WIDTH_AURA_TRUMP = 307 * SCALE_RESOLUTION;

//printed size of trumps
int const WIDTH_TRUMP = 50 * SCALE_RESOLUTION; // = HEIGHT_TRUMP for real trumps

//computation of sizes ingame
int const WIDTH_AURA = (WIDTH_TOKEN * SCALE_RESOLUTION * REAL_WIDTH_AURA_TOKEN) / REAL_WIDTH_TOKEN;
int const WIDTH_ALL_WITHOUT_TRUMP = REAL_WIDTH_ALL_WITHOUT_TRUMP * WIDTH_TRUMP / REAL_HEIGHT_TRUMP;
int const HEIGHT_AURA_TRUMP = REAL_HEIGHT_AURA_TRUMP * WIDTH_TRUMP / REAL_HEIGHT_TRUMP;
int const WIDTH_AURA_TRUMP = REAL_WIDTH_AURA_TRUMP * WIDTH_ALL_WITHOUT_TRUMP / REAL_WIDTH_ALL_WITHOUT_TRUMP;

//distances between elements
int const DIST_BETWEEN_TOKEN = 10 * SCALE_RESOLUTION;
int const DIST_BETWEEN_TRUMP = 20 * SCALE_RESOLUTION;
int const DIST_BETWEEN_TOKEN_TRUMP = 30 * SCALE_RESOLUTION;
