#include "GUI/Card.hpp"

std::string name_value[9] = {"chat","chien","jongleur","musicien","fou","valet","cavalier","dame","roi"};
std::string name_color[5] = {"","trefle", "carreau","coeur","pique"};

// using namespace sf;

//________________________Constructor____________________________

Card::Card() : AnimatedSprite(WIDTH_CARD,LENGTH_CARD){
    m_speed = 15;
    set_position(WINDOW_WIDTH/2,WINDOW_HEIGHT/2);

	m_isVisible = false;
	m_speedReturn = 0.1;
    m_advancementReturn = 1;

	set_texture("carte_final/base-dos.png");

	m_textureSprite->setSmooth(true);
	set_scale(SCALE_CARD);
}

Card::Card(Core::Value value, Core::Suit color) : Card() {
	m_cardData = Core::Card(color, value);
	flip_card(C_DISTRIB_TIME);
}

Card::Card(Core::Card typeCard) : Card(){
    m_cardData = typeCard;
    flip_card(C_DISTRIB_TIME);
}

//_________________________Draw_Function___________________________


//_________________________Move_Function___________________________

void Card::flip_card(int time){
    m_speedReturn = 2/double(time);
	m_isVisible = !m_isVisible;
	m_advancementReturn = -1;
}

void Card::flip_card(Core::Card typeCard, int time){
    m_isVisible = true;
    m_cardData = typeCard;
    m_advancementReturn = -1;
    m_speedReturn = 2/double(time);
}

void Card::continue_move(){
    AnimatedTransformable::continue_move();
    if(m_advancementReturn < 1){

        m_advancementReturn += m_speedReturn;
        if(m_advancementReturn >= 1){
            m_advancementReturn = 1;
        }
        if(m_advancementReturn < m_speedReturn && m_advancementReturn >= 0){
            if(m_isVisible){
                set_texture("carte_final/"+name_value[int(m_cardData.value())]+"-"+name_color[int(m_cardData.suit())]+".png");
            }
            else{
                set_texture("carte_final/base-dos.png");
            }
        }
        setScale(sin(PI/2*m_advancementReturn)*getScale().y, getScale().y);
    }
}

void Card::update(sf::RenderWindow& window) {
    continue_move();
    window.draw(*this);
}

bool Card::is_animated(){
    return (m_advancementReturn < 1 || AnimatedTransformable::is_animated());
}

//_________________________Event_Function___________________________

//_________________________Setter_Getter____________________________

bool Card::is_visible(){
	return m_isVisible;
}

Core::Suit Card::get_color(){
	return m_cardData.suit();
}

Core::Value Card::get_value(){
	return m_cardData.value();
}

Core::Card Card::get_card_data(){
    return m_cardData;
}
