#include "DropDownMenu.hpp"

const std::wstring rank_name[4] = {L"(1st)",L"(2nd)",L"(3rd)",L"(4th)"};

bool const DropDownMenu::MENU_ON_RIGHT = false;
int const DropDownMenu::MENU_WIDTH = 250;
int const DropDownMenu::MENU_HEIGHT = 600;
int const DropDownMenu::BUTTON_MENU_SIZE = 40;

DropDownMenu::DropDownMenu(const Core::GameState *gameState) :
    m_background(MENU_WIDTH,MENU_HEIGHT, false),
    m_upDownButton( WINDOW_WIDTH*MENU_ON_RIGHT + ( 1 - 2*MENU_ON_RIGHT)*(5 + BUTTON_MENU_SIZE/2)
        , 5 + BUTTON_MENU_SIZE/2, "coin_1.png", "coin_2.png", "coin_2.png", BUTTON_MENU_SIZE, BUTTON_MENU_SIZE, true)
{
    m_x = WINDOW_WIDTH*MENU_ON_RIGHT + ( 1 - 2*MENU_ON_RIGHT)*(BUTTON_MENU_SIZE + 10) - MENU_WIDTH*(1-MENU_ON_RIGHT);
    m_y = 10 + BUTTON_MENU_SIZE - MENU_HEIGHT;

    m_background.set_color(sf::Color(0,0,255));

    sf::Color colorText = WHITE;

    m_gameState = gameState;
    m_isDown = false;
    m_numberRound = 1;

    //______ Initialize the background Sprite ______

    m_background.set_position(m_x,m_y); // initially folded
    m_background.set_texture(RM.get_texture("DDMTexture.png"));

    //______ Initialize messages ______

    m_messageArray.emplace_back(m_x+5, m_y + 5, 25, "round", "MPlantin_0.ttf", colorText, Align::LEFT);

    m_messageArray.emplace_back(m_x+5, m_y + 65, 25, "currentTrump", "MPlantin_0.ttf", colorText, Align::LEFT);
    m_spriteArray.emplace_back(30,30,false);
    m_spriteArray[SPR_TRUMP].set_position(m_x + 190, m_y + 60);

    m_spriteArray[SPR_TRUMP].set_texture("vide.png");
    m_messageArray.emplace_back(m_x+5, m_y + 100, 25, "lastTrick", "MPlantin_0.ttf", colorText, Align::LEFT);

    m_messageArray.emplace_back(m_x+90, m_y + 215, 30, L"", "MPlantin_0.ttf", colorText, Align::LEFT);
    m_messageArray.emplace_back(m_x+15, m_y + 175, 30, L"", "MPlantin_0.ttf", colorText, Align::LEFT);
    m_messageArray.emplace_back(m_x+90, m_y + 135, 30, L"", "MPlantin_0.ttf", colorText, Align::LEFT);
    m_messageArray.emplace_back(m_x+165, m_y + 175, 30, L"", "MPlantin_0.ttf", colorText, Align::LEFT);

    m_spriteArray.emplace_back(30,30,false);
    m_spriteArray.emplace_back(30,30,false);
    m_spriteArray.emplace_back(30,30,false);
    m_spriteArray.emplace_back(30,30,false);
    m_spriteArray[SPR_PLAY1].set_position(m_x + 115, m_y + 210);
    m_spriteArray[SPR_PLAY2].set_position(m_x + 40, m_y + 170);
    m_spriteArray[SPR_PLAY3].set_position(m_x + 115, m_y + 130);
    m_spriteArray[SPR_PLAY4].set_position(m_x + 190, m_y + 170);
    m_spriteArray[SPR_PLAY1].set_texture("vide.png");
    m_spriteArray[SPR_PLAY2].set_texture("vide.png");
    m_spriteArray[SPR_PLAY3].set_texture("vide.png");
    m_spriteArray[SPR_PLAY4].set_texture("vide.png");
    m_spriteArray.emplace_back(40,60,false);
    m_spriteArray.emplace_back(40,40,false);
    m_spriteArray[CARD].set_position(m_x + 50, m_y + 425);
    m_spriteArray[TOKEN].set_position(m_x + 155, m_y + 435);
    m_spriteArray[CARD].set_texture("carte_final/base-dos.png");
    m_spriteArray[TOKEN].set_texture("sprites_token/token_white.png");


    m_messageArray.emplace_back(m_x+5, m_y + 270, 25, "score", "MPlantin_0.ttf", colorText,  Align::LEFT);


    m_messageArray.emplace_back(m_x+95, m_y + 385, 30, L"0", "MPlantin_0.ttf", WHITE,  Align::LEFT);
    m_messageArray.emplace_back(m_x+25, m_y + 345, 30, L"0", "MPlantin_0.ttf", WHITE,  Align::LEFT);
    m_messageArray.emplace_back(m_x+95, m_y + 305, 30, L"0", "MPlantin_0.ttf", WHITE,  Align::LEFT);
    m_messageArray.emplace_back(m_x+165, m_y + 345, 30, L"0", "MPlantin_0.ttf", WHITE,  Align::LEFT);

    m_messageArray.emplace_back(m_x+115, m_y + 385, 20, L"(1st)", "MPlantin_0.ttf", GRAY,  Align::LEFT);
    m_messageArray.emplace_back(m_x+45, m_y + 345, 20, L"(1st)", "MPlantin_0.ttf", GRAY,  Align::LEFT);
    m_messageArray.emplace_back(m_x+115, m_y + 305, 20, L"(1st)", "MPlantin_0.ttf", GRAY,  Align::LEFT);
    m_messageArray.emplace_back(m_x+185, m_y + 345, 20, L"(1st)", "MPlantin_0.ttf", GRAY,  Align::LEFT);


    m_messageArray.emplace_back(m_x+45, m_y + 445, 30, L"5", "MPlantin_0.ttf", WHITE,  Align::RIGHT);
    m_messageArray.emplace_back(m_x+150, m_y + 445, 30, L"5", "MPlantin_0.ttf", WHITE,  Align::RIGHT);
    //TODO move mechoune down

    //m_messageArray.emplace_back(m_x+5, m_y + 445, 25, L"Mechouné!! ", "MPlantin_0.ttf", colorText,  Align::LEFT);
    m_messageArray.emplace_back(m_x+5, m_y + 445, 25, L" ", "MPlantin_0.ttf", colorText,  Align::LEFT);

}

//______________________ Movement functions ________________________

void DropDownMenu::drop_down() {
    sf::Vector2f move( (MENU_WIDTH - BUTTON_MENU_SIZE - 10)*( 1 - 2*MENU_ON_RIGHT)
                    , MENU_HEIGHT - BUTTON_MENU_SIZE - 10);
    m_background.move_sprite_relative(move, 0, m_dropDownSpeed);
    for(unsigned int i=0; i<m_spriteArray.size(); i++){
        m_spriteArray[i].move_sprite_relative(move, 0, m_dropDownSpeed);
    }
    for(unsigned int i=0; i<m_messageArray.size(); i++){
        m_messageArray[i].move_sprite_relative(move, 0, m_dropDownSpeed);
    }
    m_upDownButton.move_sprite_relative(move, 0, m_dropDownSpeed);
    m_upDownButton.set_angle(180);
}

void DropDownMenu::fold_back_up() {
    sf::Vector2f move( (MENU_WIDTH - BUTTON_MENU_SIZE - 10)*( 1 - 2*MENU_ON_RIGHT)
                    , MENU_HEIGHT - BUTTON_MENU_SIZE - 10);
    m_background.move_sprite_relative(-move, 0, m_dropDownSpeed);
    for(unsigned int i=0; i<m_spriteArray.size(); i++){
        m_spriteArray[i].move_sprite_relative(-move, 0, m_dropDownSpeed);
    }
    for(unsigned int i=0; i<m_messageArray.size(); i++){
        m_messageArray[i].move_sprite_relative(-move, 0, m_dropDownSpeed);
    }
    m_upDownButton.move_sprite_relative(-move, 180, m_dropDownSpeed);
    m_upDownButton.set_angle(0);
}

void DropDownMenu::react_to_click() {
    if (not m_background.is_animated()) {
        if (m_isDown)
            fold_back_up();
        else
            drop_down();
        m_isDown = !m_isDown;
    }
}

//______________________Draw_And_Update_Functions________________________

void DropDownMenu::update(sf::RenderWindow& window, sf::Vector2i const mousePos, bool const clicked){
    update(window, mousePos.x, mousePos.y, clicked);
}

void DropDownMenu::update(sf::RenderWindow& window, sf::Vector2f const mousePos, bool const clicked){
    update(window, mousePos.x, mousePos.y, clicked);
}

void DropDownMenu::update(sf::RenderWindow& window, float const mouseX, float const mouseY, bool const clicked) {
    if(m_gameState->state_changed()){

        const Core::CardStack& lastTrick = m_gameState->last_card_stack();
        int opener = lastTrick.id_first_player();

        const Core::AllBets& allBet = m_gameState->bets();
        int idBest = m_gameState->id_best_bet();

        switch(m_gameState->game_part()){

            case Core::GamePart::BetPart :
                m_messageArray[PART].set_text("betPhase");

                m_messageArray[TRICK].set_text("playerBet");
                for(unsigned int i=0; i<allBet.size(); i++){
                    m_spriteArray[SPR_PLAY1 + (i + idBest)%4 ].set_texture("sprites_token/"+trump_to_string(allBet[i].trump)+".png"); //bug here need modif of core
                    m_messageArray[T_PLAY1 + (i + idBest)%4 ].set_text(std::to_wstring( allBet[i].value ));
                }
                for(unsigned int i=allBet.size()+1; i<4; i++){
                    m_spriteArray[SPR_PLAY1 + (i + idBest)%4 ].set_texture("vide.png"); //bug here
                    m_messageArray[T_PLAY1 + (i + idBest)%4 ].set_text(L"");
                }

                break;

            case Core::GamePart::CardPlayingPart :
                m_messageArray[PART].set_text("playPhase");

                m_messageArray[TRICK].set_text("lastTrick");

                if(!lastTrick.empty()){
                    for(int i=0; i<4; i++){ 
                        if(opener!=-1){
                            m_spriteArray[SPR_PLAY1 + (i + opener)%4].set_texture("sprites_token/"+ suit_to_string(lastTrick.stack()[i].suit())+".png");
                            m_messageArray[T_PLAY1 + (i + opener)%4].set_text(NAME_VALUE[int(lastTrick.stack()[i].value())]);
                        }
                    }
                }
                else{
                    for(int i=0; i<4; i++){
                        m_spriteArray[SPR_PLAY1 + i].set_texture("vide.png");
                        m_messageArray[T_PLAY1 + i].set_text(L"");
                    }
                }

                break;
            case Core::GamePart::NotBeganYet :
                m_messageArray[PART].set_text("round");
                break;
            default:
                m_messageArray[PART].set_text(L"Not Found");
                break;
        }

        m_messageArray[NB_CARDS].set_text(std::to_wstring(m_gameState->nb_cards_round()));
        int nb_total_bets = 0;
        for(auto nb_player : m_gameState->nb_tricks_objective())
            nb_total_bets+=nb_player;
        m_messageArray[NB_BETS].set_text(std::to_wstring(nb_total_bets));
        m_spriteArray[SPR_TRUMP].set_texture("sprites_token/"+trump_to_string(m_gameState->best_bet().trump)+".png");

        if(m_gameState->is_mechoune()){
            m_messageArray[CHOUNE].set_text(L"Mechouné!!");
        }
        else if(m_gameState->is_choune()){
            m_messageArray[CHOUNE].set_text(L"Chouné!!!");
        }
        else{
            m_messageArray[CHOUNE].set_text(L"");
        }

        const auto& score = m_gameState->get_scores();

        for(int i=0;i<4; i++){
            m_messageArray[S_PLAY1+i].set_text(std::to_wstring(score[i]));
        }

        //const sf::Color rank_color[4] = {BLUE,WHITE,YELLOW,RED};
        std::array<int, 4> rank = score;
        std::sort(rank.begin(),rank.end());
        for(int j=3; j>=0; j--){
            for(int i=0;i<4; i++){
                if(score[i]==rank[j]){
                    m_messageArray[R_PLAY1 + i].set_text(rank_name[j]);
                    //m_messageArray[S_PLAY1 + i].set_color(rank_color[j]);
                }
            }
        }

    }

    m_background.update(window);
    for(unsigned int i=0; i<m_spriteArray.size(); i++){
        m_spriteArray[i].update(window);
    }
    for(unsigned int i=0; i<m_messageArray.size(); i++){
        m_messageArray[i].update(window);
    }
    m_upDownButton.update(window, mouseX, mouseY);
    if (m_upDownButton.is_lit() and clicked) {
        react_to_click();
    }
}
