#include "Loading.hpp"
#include "Constants.hpp"

using namespace std;

wstring Loading::onePt = L".";
wstring Loading::twoPt = L"..";
wstring Loading::threePt = L"...";

int const Loading::SPRITE_OFFSET = 40;

Loading::Loading(float posX, float posY) :
    m_loadingPhase(0),
    m_loadStr(textManager.get_entry("loading")),
    m_loadingMessage(posX, posY, MENU_BUTTON_FONT_SIZE, L"", "MPlantin_0.ttf", WHITE, Align::LEFT),
    m_loadingSprite(WINDOW_HEIGHT/10, WINDOW_HEIGHT/10)
{
    m_loadingSprite.set_texture("fou.png");
    m_loadingSprite.set_position(posX-SPRITE_OFFSET, posY);
}

Loading::Loading(sf::Vector2i position) : Loading(position.x, position.y) {}
Loading::Loading(sf::Vector2f position) : Loading(position.x, position.y) {}

void Loading::update(sf::RenderWindow& window) {
    if(not m_loadingSprite.is_animated()) {
      m_loadingPhase=(m_loadingPhase+1)%4;
      m_loadingSprite.move_sprite_relative(0, 0, 120, 5);
      switch (m_loadingPhase) {
          case 1:
            m_loadingMessage.set_text(m_loadStr+onePt);
            break;
          case 2:
            m_loadingMessage.set_text(m_loadStr+twoPt);
            break;
          case 3:
            m_loadingMessage.set_text(m_loadStr+threePt);
            break;
          default:
            m_loadingMessage.set_text(m_loadStr);
            break;
      }
    }
    m_loadingMessage.update(window);
    m_loadingSprite.update(window);
}
