
#include "TrophiesDrawer.hpp"

using namespace std;

TrophiesDrawer::TrophiesDrawer() : m_background(WIDTH_TROPHIES_DRAWER,HEIGHT_TROPHIES_DRAWER, false),
        m_trophyPicture(SIZE_TROPHIES_PICTURE, SIZE_TROPHIES_PICTURE),
        m_textTrophy(WINDOW_WIDTH-WIDTH_TROPHIES_DRAWER+HEIGHT_TROPHIES_DRAWER, WINDOW_HEIGHT+3.2*TROPHY_TEXT_SIZE, TROPHY_TEXT_SIZE, L"","MPlantin_0.ttf", WHITE, Align::LEFT),
        m_nameTrophy(WINDOW_WIDTH-WIDTH_TROPHIES_DRAWER+HEIGHT_TROPHIES_DRAWER, WINDOW_HEIGHT+20, TROPHY_NAME_SIZE, L"","MPlantin_0.ttf", WHITE, Align::LEFT),
        m_isDrawn(false)
{
        m_trophyPicture.set_position(WINDOW_WIDTH-WIDTH_TROPHIES_DRAWER+HEIGHT_TROPHIES_DRAWER/2, WINDOW_HEIGHT+HEIGHT_TROPHIES_DRAWER/2);
        m_background.set_position(WINDOW_WIDTH-WIDTH_TROPHIES_DRAWER, WINDOW_HEIGHT);
        m_background.set_texture("DDMTexture.png");
}
                            
void TrophiesDrawer::update(sf::RenderWindow &app) {
    if(!m_isDrawn && !m_background.is_animated()){
        if(statManager.new_trophy()){
            m_isDrawn = true;
            m_trophyDrawn = static_cast<int>(statManager.get_next_trophy());
            
            auto name = textManager.get_entry("nameTrophy"+to_string(m_trophyDrawn+1));
            split_string(name , TROPHY_NAME_SIZE, WIDTH_TROPHIES_DRAWER-HEIGHT_TROPHIES_DRAWER);
            m_nameTrophy.set_text(name);
                
            auto text = textManager.get_entry("textTrophy"+to_string(m_trophyDrawn+1));
            split_string(text , TROPHY_TEXT_SIZE, WIDTH_TROPHIES_DRAWER-HEIGHT_TROPHIES_DRAWER);
            m_textTrophy.set_text(text);
                
            m_trophyPicture.set_texture("trophies/picture"+to_string(m_trophyDrawn+1)+".png");
            m_timer.restart();
            
            m_trophyPicture.move_sprite_relative(0,-HEIGHT_TROPHIES_DRAWER,0,20);            
            m_background.move_sprite_relative(0,-HEIGHT_TROPHIES_DRAWER,0,20);
            m_nameTrophy.move_sprite_relative(0,-HEIGHT_TROPHIES_DRAWER,0,20);
            m_textTrophy.move_sprite_relative(0,-HEIGHT_TROPHIES_DRAWER,0,20);
        }
    } else {
        m_background.update(app);
        m_textTrophy.update(app);
        m_nameTrophy.update(app);
        m_trophyPicture.update(app);
        
        if(m_isDrawn && m_timer.getElapsedTime().asMilliseconds() >= TIME_TROPHY_APPEAR){
            m_isDrawn = false;
            m_trophyPicture.move_sprite_relative(0,HEIGHT_TROPHIES_DRAWER,0,20);
            m_background.move_sprite_relative(0,HEIGHT_TROPHIES_DRAWER,0,20);
            m_nameTrophy.move_sprite_relative(0,HEIGHT_TROPHIES_DRAWER,0,20);
            m_textTrophy.move_sprite_relative(0,HEIGHT_TROPHIES_DRAWER,0,20);
        }
    }
}
