#include "GUI.hpp"

using namespace std;

GUI::GUI() :
	m_serverLink(optionManager()->get_default_server_IP(), optionManager()->get_default_server_port()),
    m_splashActive(false)
{

	// Initializing the Window
	sf::VideoMode videoMode = optionManager()->get_window_settings();

	if (optionManager()->is_full_screen())
		app.create(videoMode, "cartomENSia", sf::Style::Fullscreen);
	else
		app.create(videoMode, "cartomENSia", sf::Style::Close | sf::Style::Titlebar);

    app.setTitle("cartomENSia");
    app.setPosition(sf::Vector2i(20, 10));
    app.setFramerateLimit(60);

	// icon of the program
    sf::Image icon;
    if(!icon.loadFromFile("res/images/fou.png")) {
        cout << "ERROR : App's icon couldn't be loaded !\n";
    }
    app.setIcon(64, 64, icon.getPixelsPtr());

	// Splash screen
	m_splashScreen.set_texture("splash_screen.png");
	m_splashScreen.set_transparency(12);
}

void GUI::run() {
	run_login();
}
