#include "enumType.hpp"
#include <iostream>

std::string language_to_string(Language const l) {
    switch (l) {
        case Language::ENGLISH:
            return "EN";
            break;
        case Language::FRENCH:
            return "FR";
            break;
        case Language::GERMAN:
            return "GER";
            break;
        case Language::SPANISH:
            return "SPA";
            break;
        case Language::ITALIAN:
            return "ITA";
            break;
        case Language::PIRATE:
            return "PIR";
            break;
        case Language::PORTUGUESE:
            return "POR";
            break;
        default:
            return "";
    }
}

Language string_to_language(std::string const& str) {
    if (str=="EN")
        return Language::ENGLISH;
    if (str=="GER")
        return Language::GERMAN;
    if (str=="SPA")
        return Language::SPANISH;
    if (str=="ITA")
        return Language::ITALIAN;
    if (str=="POR")
        return Language::PORTUGUESE;
    if (str=="PIR")
        return Language::PIRATE;
    return Language::FRENCH;
}

std::string difficulty_to_string(Difficulty const d) {
    switch (d) {
        case Difficulty::EASY:
            return "easy";
        case Difficulty::HARD:
            return "hard";
        case Difficulty::MEDIUM:
        default:
            return "medium";
    }
}

Difficulty string_to_difficulty(std::string const& str){
    if (str=="easy")
        return Difficulty::EASY;
    if (str=="hard")
        return Difficulty::HARD;
    return Difficulty::MEDIUM;
}
